.\" Source: afterimage.h 
.\" Generated with ROBODoc Version 3.2.3 (Jul 29 2001)
.\" ROBODoc (c) 1994-2001 by Frans Slothouber and Jacco van Weert.
.\" t
.\" @(#)afterimage.h.3
.TH afterimage.h 1 "Mon Feb 18 2002" afterimage.h 3
.PM Generated from afterimage.h with ROBODoc v3.2.3 on Mon Feb 18 01:14:58 2002

.SH libAfterImage/libAfterImage
.SS\fB NAME\fP 
.nf
\fR  \fBlibAfterImage\fP

\fP 
.fi
.SS\fB SYNOPSIS\fP 
.nf
 Generic imaging library originally designed for AfterStep X \fBWindow\fP
 Manager\.


.fi
.SS\fB PURPOSE\fP 
.nf
 \fBlibAfterImage\fP is the imaging library implemented for AfterStep
 X \fBWindow\fP Manager\. It has been generalized to be suitable for any
 application in need of robust graphics engine\.

 It provides facilities for loading images from files of different
 formats, compressed in memory storage of images, scaling,
 tinting/shading, flipping and superimposition of arbitrary number of
 images over each other\. In addition it allows for linear gradients
 drawing, and antialiased/smoothed \fBtext\fP drawing using both  \fBFreeType\fP
 library and X \fBWindow\fP fonts\.

 Primary goals of this library are to achieve exceptional \fBquality\fP of
 images and \fBtext\fP, making code fast and small at the same time\.
 Additional steps are taken to compensate for screen colordepth
 limitation, and different error diffusion algorithms are used to
 provide for smooth images even in low colordepth modes\.


.fi
.SS\fB HISTORY\fP 
.nf
 \fBlibAfterImage\fP has been implemented as an attempt to address several
 issues\. First one, and most important is that X \fBWindow\fP System
 completely lacks any tools for image manipulation, except for very
 rudimentary operations\. With Introduction of Render extentions in
 XFree86 4\.0 that situation is changing, but still is far from
 perfect\. There need is therefore to implement client side image
 manipulation\. That inturn creates a problem of image data transfer
 between Server and client\.

 To avoid that full\-time image storage on the client side is needed\.
 Which is memory extensive\. So there appears to be a need for some
 in\-memory \fBcompression\fP\.

 On the other side there is an image \fBquality\fP issue\. Its easy to write
 a scaling function by simply dropping out or duplicating pixels,
 but \fBquality\fP is awfull\. What is needed is very fast
 averaging/interpolation code\. That brings us to the issue of 8 bits
 per channel\. Add two pixels together and you get overflow\. So all the
 math has to be performed in different \fBcolorspace\fP and then converted
 back\. On the other side, such a conversion may discard valuable bits,
 so some compensation method has to be implemented\.

 On the \fBtext\fP drawing side of things, there are numerous problems just
 as well\. Native X fonts look ugly as soon as you try to show any
 decently sized \fBtext\fP\. That is supposed to be solved with said Render
 extensions to XFree86, but as experiense has shown, things aren't as
 easy as it looks, besides one wants his app to run well under any X
 Server\. \fBFreeType\fP library provides a solution, but not always
 available\. Another problem is that if you keep all your images on the
 client side, you want to draw \fBtext\fP on client side as well\.

 The solution is to provide transparent interface that could use both
 X fonts and \fBFreeType\fP, cache glyphs on the client side and possibly
 perform smoothing of ugly X fonts\.

 There is no library solving all this problems in one fell swoop,
 except for monstrous ones, like ImLib\.

 Hence \fBlibAfterImage\fP has come to life\.


.fi
.SS\fB DESCRIPTION\fP 
.nf
 libAfterStep provides sevarl facilities\.

 1\. X \fBVisual\fP abstruction layer via \fBASVisual\fP\. This layer handles color
 management, transfer of data to and from X Server, and other screen
 related stuff\.

 2\. Scanline handling facility via \fBASScanline\fP\. \fBASScanline\fP is the most
 widely used structure since image handling is implemented on
 per\-scanline basis\.

 3\. Image storage, trasformation and rendering via \fBASImage\fP\. \fBASImage\fP
 provides for generic container used for any image or \fBtext\fP
 manipulation\. It incorporates such a robust facilities as in\-memory
 RLE \fBcompression\fP, separate channel storage of 4 channels ( Alpha, Red,
 Green, and Blue ) with 8 bit per channel\.

 4\. Simplified font handling facility via \fBASFont\fP and ASFointManager\.
 All the font handling is done using \fBASFont\fP structure, no matter what
 type of font is used\. Any font supported by X11 and \fBFreeType\fP can be
 used\.

 5\. Transparent image file reading for many different formats\. Included
 built\-in XPM reading code and XCF ( GIMP's native format )\.
 Overall supported:
 via external libraries :
 XPM, JPEG, PNG, TIFF, GIF
 via built in code :
 XPM, XCF, PNM, PPM, BMP, ICO, CUR
 Note that XPM can be supported both via built\-in code or via libXpm,
 depending on compilation configuration\.
 Actuall image file format is autodetected from the file contents \-
 file name extention is not used and can be anything at all\.

 6\. Image export into many popular file formats\. Currently implemented :
 XPM, JPEG, PNG, GIF\. Work is underway to implement support for TIFF,
 XCF, BMP, ICO\.

 7\. Image quantization to arbitrary size colormap\.

 8\. \fBlibAfterImage\fP could be used without X \fBwindow\fP system, which is
 coninient for such thing as web development\. XML Image manipulation
 tool, that could be used in such activity is included (see ascompose\.c)

 9\. Image reference counting


.fi
.SS\fB USES\fP 
.nf
 libAfterBase \- AfterStep basic functionality library\. That Includes
 Hash tables, file search methods, message output, generic types\.
 However effort has been made to allow for standalone configuration as
 well\. If libAfterBase is not found at compilation time \- \fBlibAfterImage\fP
 will use extract from libAfterBase included with \fBlibAfterImage\fP\.


.fi
.SS\fB SEE ALSO\fP 
.nf
 \fBExamples\fP
 \fBAPI\fP Reference


.fi
.SS\fB TODO\fP 
.nf
 Implement support for Targa and PCX image format and maybe some other
 formats as well\.

 Implement complete support for I18N internationalization\.

 Implement color<\->\fBpixel\fP conversion for all colordepths\.


.fi
.SS\fB AUTHOR\fP 
.nf
\fB  Sasha Vasko <sasha at aftercode dot net>
\fP 
.fi

.PP
.SH libAfterImage/Examples
.SS\fB EXAMPLE\fP 
.nf
 \fBASView\fP  \- image loading from the file and displaying in \fBwindow\fP\.
 \fBASScale\fP \- image loading from file and scaling to arbitrary size\.
 \fBASTile\fP  \- image loading from file, tiling and tinting to arbitrary
           size and color\.
 \fBASMerge\fP \- imgae loading and merging with another image\.
 \fBASGrad\fP  \- mutlipoint \fBgradient\fP drawing\.
 \fBASFlip\fP  \- image loading from file and rotation\.
 \fBASText\fP  \- trexturized semitransparent antialised \fBtext\fP drawing\.


.fi
.SS\fB SEE ALSO\fP 
.nf
 \fBAPI\fP Reference

.fi

.PP
.SH libAfterImage/API
.SS\fB CHILDREN\fP 
.nf
 Headers :
          \fBascmap.h\fP \fBasfont.h\fP \fBasimage.h\fP \fBasvisual.h\fP \fBblender.h\fP \fBexport.h\fP
          \fBimport.h\fP \fBtransform.h\fP \fBximage.h\fP
 Structures :
          \fBColorPair\fP
          \fBASScanline\fP
          \fBASVisual\fP
          \fBASImage\fP
          \fBASImageManager\fP
          \fBASImageBevel\fP
          \fBASImageDecoder\fP
          \fBASImageOutput\fP
          \fBASImageLayer\fP
          \fBASGradient\fP
          \fBASFontManager\fP
          \fBASFont\fP
          \fBASGlyph\fP
          \fBASGlyphRange\fP
          \fBASColormap\fP
          \fBASImageExportParams\fP
          \fBASVectorPalette\fP

 Functions :
   \fBASScanline\fP handling:
        \fBprepare_scanline()\fP, \fBfree_scanline()\fP

   \fBASVisual\fP initialization :
        \fBquery_screen_visual()\fP, \fBsetup_truecolor_visual()\fP,
        \fBsetup_pseudo_visual()\fP, \fBsetup_as_colormap()\fP,
          \fBcreate_asvisual()\fP, \fBcreate_asvisual_for_id()\fP,
        \fBdestroy_asvisual()\fP

   \fBASVisual\fP encoding/decoding :
        \fBvisual2visual_prop()\fP, \fBvisual_prop2visual()\fP

   \fBASVisual\fP convenience functions :
        \fBcreate_visual_window()\fP, \fBcreate_visual_pixmap()\fP,
        \fBcreate_visual_ximage()\fP, create_visual_gc()

   Colorspace conversion :
          \fBrgb2value()\fP, rgb2saturation(), rgb2hue(), rgb2luminance(),
          \fBrgb2hsv()\fP, rgb2hls(), \fBhsv2rgb()\fP, hls2rgb(),
          degrees2hue16(), hue162degrees(), normalize_degrees_val()

   Image quantization :
          \fBcolormap_asimage()\fP, \fBdestroy_colormap()\fP

   \fBmerge_scanline\fP methods :
          alphablend_scanlines(), allanon_scanlines(),
          \fBtint\fP_scanlines(), add_scanlines(), sub_scanlines(),
          diff_scanlines(), darken_scanlines(), lighten_scanlines(),
          screen_scanlines(), overlay_scanlines(), hue_scanlines(),
          saturate_scanlines(), value_scanlines(),
          colorize_scanlines(), dissipate_scanlines()\.

   \fBASImage\fP handling :
          \fBasimage_init()\fP, \fBasimage_start()\fP, \fBcreate_asimage()\fP,
          \fBclone_asimage()\fP, \fBdestroy_asimage()\fP

   \fBASImage\fP channel data manipulations :
          \fBget_asimage_chanmask()\fP, \fBmove_asimage_channel()\fP,
          \fBcopy_asimage_channel()\fP, \fBcopy_asimage_lines()\fP

   \fBImageManager\fP Reference counting and managing :
          \fBcreate_image_manager()\fP, \fBdestroy_image_manager()\fP,
          \fBstore_asimage()\fP, \fBfetch_asimage()\fP, \fBdup_asimage()\fP,
          \fBrelease_asimage()\fP, \fBrelease_asimage_by_name()\fP

   \fBLayers\fP helper functions :
          \fBinit_image_layers()\fP, \fBcreate_image_layers()\fP,
          \fBdestroy_image_layers()\fP

   \fBEncoding\fP :
          \fBasimage_add_line()\fP,   \fBasimage_add_line_mono()\fP,
          \fBasimage_print_line()\fP

   \fBDecoding\fP :
          \fBstart_image_decoding()\fP, \fBstop_image_decoding()\fP,
          asimage_decode_line (), \fBset_decoder_shift()\fP,
          \fBset_decoder_bevel_geom()\fP, \fBset_decoder_back_color()\fP

   \fBASImage\fP from scientific data :
          set_asimage_vector(), \fBcolorize_asimage_vector()\fP,
          \fBcreate_asimage_from_vector()\fP

   \fBOutput\fP :
          \fBstart_image_output()\fP, \fBset_image_output_back_color()\fP,
          \fBtoggle_image_output_direction()\fP, \fBstop_image_output()\fP

   X11 conversions :
          \fBximage2asimage()\fP, \fBpixmap2asimage()\fP, \fBasimage2ximage()\fP,
          \fBasimage2mask_ximage()\fP, \fBasimage2pixmap()\fP, \fBasimage2mask()\fP

   Transformations :
          \fBscale_asimage()\fP, \fBtile_asimage()\fP, \fBmerge_layers()\fP, \fBmake_gradient()\fP,
          \fBflip_asimage()\fP, \fBmirror_asimage()\fP, \fBpad_asimage()\fP,
          \fBblur_asimage_gauss()\fP, \fBfill_asimage()\fP, \fBadjust_asimage_hsv()\fP

   Import :
          \fBfile2ASImage()\fP, \fBfile2pixmap()\fP
   Export :
        \fBASImage2file()\fP

   Text Drawing :
          \fBcreate_font_manager()\fP, \fBdestroy_font_manager()\fP,
          \fBopen_freetype_font()\fP, \fBopen_X11_font()\fP, \fBget_asfont()\fP,
          destroy_font(), \fBprint_asfont()\fP, \fBprint_asglyph()\fP,
          \fBdraw_text()\fP

.fi

.PP
